<?php
/***************************************************************************
 *	EasyBAN_HIDER.php
 *
 *	begin		: September 2006
 *	version		: 9 December 2006
 *	copyright	: (C) 2006,2007 grandolini.net
 *	email		: maraja@users.sourceforge.net
 *
 *	Hide a post/topic from the forum pending on the EasyBAN settings.
 *	If required, send a notification email to the site Admin.
 *
 *	Errors eventually generated by this code are send by email to the Admin.
 *
 *	 /==========================================================\
 *	 |                                                          |
 *	 | Quarantine does NOT update the BANLIST_TABLE on purpose! |
 *	 |                                                          |
 *	 \==========================================================/
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 ***************************************************************************/

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//	main function
//
function easyban_hider()
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
{
	global $phpEx, $phpbb_root_path, $db, $board_config, $lang, $userdata, $default_cfg_values, $post_id, $user_ip;

	include($phpbb_root_path . 'admin/EasyBAN_includes/EasyBAN_functions.' . $phpEx);
	include($phpbb_root_path . 'includes/emailer.' . $phpEx);

	//	get EasyBAN configuration settings
	//
	$settings = get_settings(1);

	//	get language strings
	//
	if ( @file_exists($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_EasyBAN.' . $phpEx) )
	{
		include($phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_EasyBAN.' . $phpEx);
	}
	else
	{
		include($phpbb_root_path . 'language/lang_english/lang_EasyBAN.' . $phpEx);
	}

	//
	//	Admin posts are ignored
	//
	if( $userdata['user_email'] != $board_config['board_email'] )
	{
		//	get post details
		//
		$sql = 'SELECT  p.topic_id,
						i.post_subject, i.post_text, 
						t.topic_title 
				FROM ' 
				. POSTS_TABLE . ' p, '
				. POSTS_TEXT_TABLE . ' i, '
				. TOPICS_TABLE . " t 
				WHERE
				p.post_id = $post_id AND 
				i.post_id = $post_id AND
				t.topic_id = p.topic_id ";
		if( !$result = $db->sql_query($sql) )
		{
			//	message_die(GENERAL_ERROR, $lang['EasyBAN_err_no_post'] . $post_id, '', __LINE__, __FILE__, $sql);
			deliver_email($board_config['sitename'] . $lang['EasyBAN_M_err'], $lang['EasyBAN_err_no_post'] . "\npost_id: " . $post_id . "\nFile:\n" . __FILE__ . "\nLine:\n" . __LINE__);
			return;
		}
		$post_dtls = $db->sql_fetchrow($result);
		$topic_id = $post_dtls['topic_id'];
	
		$quarantine = false;

		if ( $settings['EasyBAN_quar_active_radio'] == 1 )
		{
			//===============
			//	QUARANTINER
			//===============

			$hide_type = 0; // hide a post

			$quar_list = explode(',', $settings['EasyBAN_word']);

			//	if the extra words file exhists, add its contents to the to be quaratined words list
			//
			if( @file_exists($phpbb_root_path . 'admin/EasyBAN_includes/quarantine_words.txt') )
			{
				$extra_words = @file( $phpbb_root_path . 'admin/EasyBAN_includes/quarantine_words.txt' );
				if( is_array($extra_words) )
				{
					foreach( $extra_words as $word )
					{
						array_push($quar_list, $word);
					}
				}
			}
			$t = count($quar_list);

			//	check topic title for words
			//
			for( $i = 0; $i < $t; $i++ )
			{
				if( stristr($post_dtls['topic_title'], $quar_list[$i]) )
				{
					//	found at least one word
					//
					$quarantine = true;
					$hide_type = 1; // hide a topic
					$i = $t + 1; // one is enough, quit search
				}
			}

			if( $quarantine == false )
			{
				//	check post subject for words
				//
				for( $i = 0; $i < $t; $i++ )
				{
					if( stristr($post_dtls['post_subject'], $quar_list[$i]) )
					{
						//	found at least one word
						//
						$quarantine = true;
						$i = $t + 1; // one is enough, quit search
					}
				}
			}

			if( $quarantine == false )
			{
				//	check post contents for words
				//
				for( $i = 0; $i < $t; $i++ )
				{
					if( stristr($post_dtls['post_text'], $quar_list[$i]) )
					{
						//	found at least one word
						//
						$quarantine = true;
						$i = $t + 1; // one is enough, quit search
					}
				}
			}

			if( $quarantine == false )
			{
				//	check post contents for links
				//
				$max_allowed_links = $settings['EasyBAN_quar_links'];
	
				if ( $max_allowed_links != 999 )
				{
					$string = strtolower($post_dtls['post_text']);
					$needle = 'http://';
					$end_of_search = false;
					$i = 0;
					$p = 1;

					if ( strpos($string, $needle, 0) === false )
					{
						//	$needle not found
					}
					else
					{
						//	search to the end of post
						//
						while( ($end_of_search == false) ) //// && ($i <= $max_allowed_links) // until the max allowed value is reached
						{
							$p = strpos($string, $needle, $p);
							if( $p === false )
							{
								$end_of_search = true; // no more $needles
							}
							$i++;
							$p++;
						}
					}

					if ( $i > $max_allowed_links )
					{
						$quarantine = true;
					}
				}
			}

			//	move item to quarantine
			//
			if( $quarantine == true )
			{
				$sql = 'SELECT * 
						FROM ' . HIDED_TABLE . ' 
						WHERE ';
				if( $hide_type == 0 )
				{
					$sql .= "hide_id = $post_id AND ";
				}
				else
				{
					$sql .= "hide_id = $topic_id AND ";
				}
				$sql .= "hide_type = $hide_type ";
				
				if( $result = $db->sql_query($sql) )
				{
					$row_post = $db->sql_fetchrow($result);
					if( $db->sql_affectedrows() == 0 )
					{
						//	item is not yet banned, quarantine it
						//
						$sql = 'INSERT INTO ' . HIDED_TABLE . ' ( hide_id, hide_quar, hide_type ) ';
						if( $hide_type == 0 )
						{
							$sql .= "VALUES ( $post_id, 1, $hide_type ) ";
						}
						else
						{
							$sql .= "VALUES ( $topic_id, 1, $hide_type ) ";
						}
						if( !$db->sql_query($sql) )
						{
							//	message_die(GENERAL_ERROR, $lang['EasyBAN_err_noins_hide'], '', __LINE__, __FILE__, $sql);
							deliver_email($board_config['sitename'] . $lang['EasyBAN_M_err'], $lang['EasyBAN_err_noins_hide'] . "\npost_id: " . $post_id . ', topic_id: ' . $topic_id . "\nSql:\n" . $sql . "\nFile:\n" . __FILE__ . "\nLine:" . __LINE__);
							return;
						}
					}
				}
				else
				{
					//	message_die(GENERAL_ERROR, $lang['EasyBAN_err_nocheck_hide'], '', __LINE__, __FILE__, $sql);
					deliver_email($board_config['sitename'] . $lang['EasyBAN_M_err'], $lang['EasyBAN_err_nocheck_hide'] . "\npost_id: " . $post_id . ', topic_id: ' . $topic_id . "\nSql:\n" . $sql . "\nFile:\n" . __FILE__ . "\nLine:" . __LINE__);
					return;
				}
			}
		}
	}

	//===========================================
	//	send the notification email as required
	//===========================================
	$last_report_date = $settings['EasyBAN_private_last_report'];
	switch( $settings['EasyBAN_infoe'] )
	{
		case 'each':
			//
			//	one email per post
			//
			$useremail = $userdata['user_email'] ? $userdata['user_email'] : $lang['EasyBAN_no_post_email'];
			$body	= $lang['EasyBAN_M_postby'] . ' ' . $userdata['username'] . ', ' . $useremail . ', ' . decode_ip($user_ip) . "\n\n"
					. $lang['EasyBAN_M_title'] . ' ' . $post_dtls['topic_title'] . "\n"
					. $lang['EasyBAN_M_subj'] . ' ' . $post_dtls['post_subject'] . "\n"
					. $lang['EasyBAN_M_body'] . ' ' . $post_dtls['post_text'] . "\n"
					. "\n" . $lang['EasyBAN_M_link'] . "\n"
					. 'http://' . $board_config['server_name'] . $board_config['script_path'] . 'EasyBAN_MNGR.' . $phpEx . '?mode=detail&page=full&pid=' . $post_id . '&act=i';
			//		. 'http://' . $board_config['server_name'] . $board_config['script_path'] . 'login.' . $phpEx . '?redirect=admin/admin_EasyBAN.' . $phpEx . '&amp;mode=detail&amp;admin=1&amp;pid=' . $post_id . '&amp;act=i';

			if( $userdata['username'] != ANONYMOUS)
			{
				$body .= 'ue';
			}
			if( $quarantine == true )
			{
				$body	.= "\n\n" . $lang['EasyBAN_M_qlink'] . "\n";
			}

			deliver_email($board_config['sitename'] . $lang['EasyBAN_M_info'], $body);
			update_cfg_timer();
			break;

		case 'day':
			//
			//	one email per day
			//
			$time_limit = $last_report_date + 86400; // 60*60*24
			$result = send_period_report($time_limit, 'D');
			if ( $result == 'OK' )
			{
				update_cfg_timer();
			}
			break;

		case 'week':
			//
			//	one email per week
			//
			$time_limit = $last_report_date + 604800; // 60*60*24*7
			$result = send_period_report($time_limit, 'W');
			if ( $result == 'OK' )
			{
				update_cfg_timer();
			}
			break;

		case 'none':
			//
			//	no email
			//
			break;
	}
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//	send the period report
//
function send_period_report($time_limit, $period_flag)
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
{
	global $db, $board_config, $lang, $phpEx;

	if ( time() > $time_limit )
	{
		//	get list of posts since one day
		//
		$sql = 'SELECT 	p.post_id, p.post_time, p.topic_id, p.forum_id, p.poster_ip, 
						i.post_subject, i.post_text,  
						h.*, 
						u.username, u.user_email, 
						t.topic_title
				FROM ' 
					. POSTS_TABLE . ' p, '
					. POSTS_TEXT_TABLE . ' i, '
					. HIDED_TABLE . ' h, '
					. USERS_TABLE . ' u, '
					. TOPICS_TABLE . " t
				WHERE
					p.post_time > $time_limit AND 
					i.post_id = p.post_id AND 
					h.hide_id = p.post_id AND 
					u.user_id = p.poster_id AND 
					t.topic_id = p.topic_id ";

		if( !$result = $db->sql_query($sql) )
		{
			//	message_die(GENERAL_ERROR, $lang['EasyBAN_err_no_post'] . create_date($board_config['default_dateformat'], $time_limit, $board_config['board_timezone']), '', __LINE__, __FILE__, $sql);
			deliver_email($board_config['sitename'] . $lang['EasyBAN_M_err'], $lang['EasyBAN_err_no_post'] . create_date($board_config['default_dateformat'], $time_limit, $board_config['board_timezone']) . ' (' . $time_limit . ')' . "\nFile:\n" . __FILE__ . "\nLine:\n" . __LINE__);
			return;
		}

		$total_posts = 0;
		$body = '';

		while( $row = $db->sql_fetchrow($result) )
		{
			//	loop through the list to build the email body
			//
			$useremail = $row['user_email'] ? $row['user_email'] : $lang['EasyBAN_no_post_email'];

			$body .= $lang['EasyBAN_M_postby'] . ' ' . $row['username'] . ', ' . $useremail . ', ' . decode_ip($row['poster_ip']) . "\n"
				  .  $lang['EasyBAN_M_title'] . ' ' . $post_dtls['topic_title'] . "\n"
				  .  $lang['EasyBAN_M_subj'] . ' ' . $row['post_subject'] . "\n"
				  .  $lang['EasyBAN_M_body'] . ' ' . $row['post_text'] . "\n"
				  .  $lang['EasyBAN_M_linkS'] 
				  .  'http://' . $board_config['server_name'] . $board_config['script_path'] . 'EasyBAN_MNGR.' . $phpEx . '?mode=detail&page=full&pid=' . $row['post_id'] . '&act=i';
			//	  .  'http://' . $board_config['server_name'] . $board_config['script_path'] . 'login.' . $phpEx . '?redirect=admin/admin_EasyBAN.' . $phpEx . '&amp;mode=detail&amp;admin=1&amp;pid=' . $row['post_id'] . '&amp;act=i';

			if( $userdata['username'] != ANONYMOUS )
			{
				$body .= 'ue';
			}
			if( $quarantine == true )
			{
				$body .= "\n" . $lang['EasyBAN_M_qlink'] . "\n";
			}
			$body .= "\n" . $lang['EasyBAN_M___'] . "\n";
			$total_posts++;
		}
		$body .= "\n" . $lang['EasyBAN_M_total_posts'] . $total_posts . "\n";

		//	deliver the email report
		//
		$period_type = 'EasyBAN_M_info' . $period_flag;
		deliver_email($board_config['sitename'] . $lang[$period_type], $body);
	}
	return 'OK';
}
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//	update configuration timer
//
function update_cfg_timer()
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
{
	global $db, $board_config, $lang;

	$config_name = 'EasyBAN_private_last_report';
	$config_value = time();

	$sql = "SELECT *
		FROM " . CONFIG_TABLE . "
		WHERE 
		config_name = '$config_name' ";
	if( !$result = $db->sql_query($sql) )
	{
		//	message_die(GENERAL_ERROR, $lang['EasyBAN_err_config_info'], '', __LINE__, __FILE__, $sql);
		deliver_email($board_config['sitename'] . $lang['EasyBAN_M_cgferr'], $lang['EasyBAN_err_config_info'] . "\nFile:\n" . __FILE__ . "\nLine:\n" . __LINE__);
	}
	else
	{
		if( $db->sql_affectedrows() == 0 )
		{
			$sql = "INSERT INTO " . CONFIG_TABLE . " ( config_name, config_value )
					VALUES ( '$config_name', '$config_value' )" ;
			if( !$result = $db->sql_query($sql) )
			{
				//	message_die(GENERAL_ERROR, $lang['EasyBAN_err_config_info'], '', __LINE__, __FILE__, $sql);
				deliver_email($board_config['sitename'] . $lang['EasyBAN_M_cgferr'], $lang['EasyBAN_err_config_info'] . "\nFile:\n" . __FILE__ . "\nLine:\n" . __LINE__);
			}
		}
		else
		{
			$sql = "UPDATE " . CONFIG_TABLE . " 
				SET config_value = '$config_value'
				WHERE 
				config_name = '$config_name' " ;
			if( !$result = $db->sql_query($sql) )
			{
				//	message_die(GENERAL_ERROR, $lang['EasyBAN_err_config_info'], '', __LINE__, __FILE__, $sql);
				deliver_email($board_config['sitename'] . $lang['EasyBAN_M_cgferr'], $lang['EasyBAN_err_config_info'] . "\nFile:\n" . __FILE__ . "\nLine:\n" . __LINE__);
			}
		}
	}
}
?>